let line_counter = ref 0 ;;

(* Mode des paramtres. *)
type mutability =
  | IN             (* Entre. *)
  | OUT            (* Sortie. *)
  | INOUT          (* Entre-sortie. *)
 ;;

type type_spec =
  | STRING            (* Variable de type chane de caractres. *)
  | INT               (* Variable de type entire. *)
  | INT_ARRAY of int  (* Variable de type tableau de xxx entiers. *)
  | TUPLE             (* Variable de type couple *)
;;


type value =
  | Init_integer of int32
  | Init_string of string  (* La chane argument contient les guillemets initiaux et finaux. *)
  | Init_tuple of int32 * int32
;;

type variable_description = {
  var_mutability : mutability ;
  var_name : string ;
  var_type : type_spec ;
  var_init : value option
} ;;

type index = int ;;

type variable =
  | Var_atomic of string
  | Var_array of (string * index)
;;

type test = {
  test_number : int ;         (* N unique du scnario de test. *)
  test_comment : string ;     (* Commentaire du scnario de test. *)
  test_inputs : (variable * value) list ;  (* Liste des variables couples  *)
  test_results : (variable * value) list
} ;;

type shot = {
  tested_function : string ;
  tested_parameters : variable_description list ;
  tested_globvars : variable_description list ;
  tested_tests : test list
} ;;
